<?php

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://www.chiptuningreseller.com
 * @since      3.0.0
 *
 * @package    Ctr
 * @subpackage Ctr/admin/partials
 */
?>
<!-- This file should primarily consist of HTML with a little bit of PHP. -->
<div id="chiptuningreseller-settings-container">
    <div class="chiptuningreseller-masthead__logo-container">
    <img style="float:right; padding-right:40px; padding-top:20px; max-width:300px;" class="chiptuningreseller-masthead__logo" src="<?php echo esc_url( plugins_url( '../../public/assets/chiptuningreseller-logo-black.png', __FILE__ ) ); ?>" alt="ChiptuningReseller"/>
    </div>
    <form class='mar-plugin-form' method="post" action="" enctype="multipart/form-data" style="background: white;padding: 20px;border: 1px solid #ddd;margin-right: 20px;border-radius: 4px;">
    <input type="hidden" name="form_type" value="prices" />
    <h2><span class="dashicons dashicons-clipboard"></span> <?php _e("ChiptuningReseller fixed pricing", "ctr"); ?></h2>
            <?php _e("Set fixed prices for stages and other services", "ctr"); ?><br/>
            <?php _e("Put a zero 0 in the field to show the 'ask for price' text", "ctr"); ?>
            <table class="form-table">
                <tbody>
                    <tr>
                        <th scope="row"><?php _e("Fixed prices for cars", "ctr"); ?></th>
                        <td>
                            <fieldset>
                                <legend class="screen-reader-text"><span><?php _e("Show fixed prices on your site", "ctr"); ?>?</span></legend>
                                <label for="fixed_price_cars_st_1">
                                    <input name="fixed_stage_prices[cars][stage_1]" type="number" id="fixed_price_cars_st_1" placeholder="Cars Stage 1 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['cars']['stage_1'])) {
                                        echo $catalogData['fixed_stage_prices']['cars']['stage_1']; } ?>">
                                </label>
                                <label for="fixed_price_cars_st_2">
                                    <input name="fixed_stage_prices[cars][stage_2]" type="number" id="fixed_price_cars_st_2" placeholder="Cars Stage 2 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['cars']['stage_2'])) {
                                        echo $catalogData['fixed_stage_prices']['cars']['stage_2']; } ?>">
                                </label>
                                <label for="fixed_price_cars_st_3">
                                    <input name="fixed_stage_prices[cars][stage_3]" type="number" id="fixed_price_cars_st_3" placeholder="Cars Stage 3 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['cars']['stage_3'])) {
                                        echo $catalogData['fixed_stage_prices']['cars']['stage_3']; } ?>">
                                </label>
                                <label for="fixed_price_cars_dsg">
                                    <input name="fixed_stage_prices[cars][st_dsg]" type="number" id="fixed_price_cars_dsg" placeholder="Cars DSG Tuning fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['cars']['st_dsg'])) {echo $catalogData['fixed_stage_prices']['cars']['st_dsg']; } ?>">
                                </label>
                            </fieldset>
                        </td>
                    </tr>
                    <tr>
                        <th scope="row"><?php _e("Fixed prices for bikes and quads", "ctr"); ?></th>
                        <td>
                            <fieldset>
                                <legend class="screen-reader-text"><span><?php _e("Show fixed prices on your site for Bikes and Quads", "ctr"); ?>?</span></legend>
                                <label for="fixed_price_bikesquad_st_1">
                                    <input name="fixed_stage_prices[bikesquad][stage_1]" type="number" id="fixed_price_bikesquad_st_1" placeholder="Bikes + Quads St1 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['bikesquad']['stage_1'])) {
                                        echo $catalogData['fixed_stage_prices']['bikesquad']['stage_1']; } ?>">
                                </label>
                                <label for="fixed_price_bikesquad_st_2">
                                    <input name="fixed_stage_prices[bikesquad][stage_2]" type="number" id="fixed_price_bikesquad_st_2" placeholder="Bikes + Quads St2 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['bikesquad']['stage_2'])) {
                                        echo $catalogData['fixed_stage_prices']['bikesquad']['stage_2']; } ?>">
                                </label>
                                <label for="fixed_price_bikesquad_st_3">
                                    <input name="fixed_stage_prices[bikesquad][stage_3]" type="number" id="fixed_price_bikesquad_st_3" placeholder="Bikes + Quads St3 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['bikesquad']['stage_3'])) {
                                        echo $catalogData['fixed_stage_prices']['bikesquad']['stage_3']; } ?>">
                                </label>
                                <label for="fixed_price_cars_dsg">
                                    <input name="fixed_stage_prices[bikesquad][st_dsg]" type="number" id="fixed_price_bikesquad_dsg" placeholder="Bikes + Quads DSG Tuning fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['bikesquad']['st_dsg'])) {echo $catalogData['fixed_stage_prices']['bikesquad']['st_dsg']; } ?>">
                                </label>
                            </fieldset>
                        </td>
                    </tr>
                    <tr>
                        <th scope="row"><?php _e("Fixed prices for motorboats", "ctr"); ?></th>
                        <td>
                            <fieldset>
                                <legend class="screen-reader-text"><span><?php _e("Show fixed prices on your site for Motorboats", "ctr"); ?>?</span></legend>
                                <label for="fixed_price_motorboats_st_1">
                                    <input name="fixed_stage_prices[motorboats][stage_1]" type="number" id="fixed_price_motorboats_st_1" placeholder="Motorboats St1 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['motorboats']['stage_1'])) {
                                        echo $catalogData['fixed_stage_prices']['motorboats']['stage_1']; } ?>">
                                </label>
                                <label for="fixed_price_motorboats_st_2">
                                    <input name="fixed_stage_prices[motorboats][stage_2]" type="number" id="fixed_price_motorboats_st_2" placeholder="Motorboats St2 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['motorboats']['stage_2'])) {
                                        echo $catalogData['fixed_stage_prices']['motorboats']['stage_2']; } ?>">
                                </label>
                                <label for="fixed_price_motorboats_st_3">
                                    <input name="fixed_stage_prices[motorboats][stage_3]" type="number" id="fixed_price_motorboats_st_3" placeholder="Motorboats St3 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['motorboats']['stage_3'])) {
                                        echo $catalogData['fixed_stage_prices']['motorboats']['stage_3']; } ?>">
                                </label>
                                <label for="fixed_price_motorboats_dsg">
                                    <input name="fixed_stage_prices[motorboats][st_dsg]" type="number" id="fixed_price_motorboats_dsg" placeholder="Motorboats DSG Tuning fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['motorboats']['st_dsg'])) {echo $catalogData['fixed_stage_prices']['motorboats']['st_dsg']; } ?>">
                                </label>
                            </fieldset>
                        </td>
                    </tr>
                    <tr>
                        <th scope="row"><?php _e("Fixed prices for jet ski's", "ctr"); ?></th>
                        <td>
                            <fieldset>
                                <legend class="screen-reader-text"><span><?php _e("Show fixed prices on your site for Jet Ski's", "ctr"); ?>?</span></legend>
                                <label for="fixed_price_jet-skis_st_1">
                                    <input name="fixed_stage_prices[jet-skis][stage_1]" type="number" id="fixed_price_jet-skis_st_1" placeholder="Jet Ski's St1 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['jet-skis']['stage_1'])) {
                                        echo $catalogData['fixed_stage_prices']['jet-skis']['stage_1']; } ?>">
                                </label>
                                <label for="fixed_price_jet-skis_st_2">
                                    <input name="fixed_stage_prices[jet-skis][stage_2]" type="number" id="fixed_price_jet-skis_st_2" placeholder="Jet Ski's St2 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['jet-skis']['stage_2'])) {
                                        echo $catalogData['fixed_stage_prices']['jet-skis']['stage_2']; } ?>">
                                </label>
                                <label for="fixed_price_jet-skis_st_3">
                                    <input name="fixed_stage_prices[jet-skis][stage_3]" type="number" id="fixed_price_jet-skis_st_3" placeholder="Jet Ski's St3 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['jet-skis']['stage_3'])) {
                                        echo $catalogData['fixed_stage_prices']['jet-skis']['stage_3']; } ?>">
                                </label>
                            </fieldset>
                        </td>
                    </tr>
                    <tr>
                        <th scope="row"><?php _e("Fixed prices for tractors", "ctr"); ?></th>
                        <td>
                            <fieldset>
                                <legend class="screen-reader-text"><span><?php _e("Show fixed prices on your site for Tractors", "ctr"); ?>?</span></legend>
                                <label for="fixed_price_tractors_st_1">
                                    <input name="fixed_stage_prices[tractors][stage_1]" type="number" id="fixed_price_tractors_st_1" placeholder="Tractors St1 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['tractors']['stage_1'])) {
                                        echo $catalogData['fixed_stage_prices']['tractors']['stage_1']; } ?>">
                                </label>
                                <label for="fixed_price_tractors_st_2">
                                    <input name="fixed_stage_prices[tractors][stage_2]" type="number" id="fixed_price_tractors_st_2" placeholder="Tractors St2 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['tractors']['stage_2'])) {
                                        echo $catalogData['fixed_stage_prices']['tractors']['stage_2']; } ?>">
                                </label>
                                <label for="fixed_price_tractors_st_3">
                                    <input name="fixed_stage_prices[tractors][stage_3]" type="number" id="fixed_price_tractors_st_3" placeholder="Tractors St3 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['tractors']['stage_3'])) {
                                        echo $catalogData['fixed_stage_prices']['tractors']['stage_3']; } ?>">
                                </label>
                            </fieldset>
                        </td>
                    </tr>
                    <tr>
                        <th scope="row"><?php _e("Fixed prices for trucks", "ctr"); ?></th>
                        <td>
                            <fieldset>
                                <legend class="screen-reader-text"><span><?php _e("Show fixed prices on your site for trucks", "ctr"); ?>?</span></legend>
                                <label for="fixed_price_trucks_st_1">
                                    <input name="fixed_stage_prices[trucks][stage_1]" type="number" id="fixed_price_trucks_st_1" placeholder="Trucks St1 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['trucks']['stage_1'])) {
                                        echo $catalogData['fixed_stage_prices']['trucks']['stage_1']; } ?>">
                                </label>
                                <label for="fixed_price_trucks_st_2">
                                    <input name="fixed_stage_prices[trucks][stage_2]" type="number" id="fixed_price_trucks_st_2" placeholder="Trucks St2 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['trucks']['stage_2'])) {
                                        echo $catalogData['fixed_stage_prices']['trucks']['stage_2']; } ?>">
                                </label>
                                <label for="fixed_price_trucks_st_3">
                                    <input name="fixed_stage_prices[trucks][stage_3]" type="number" id="fixed_price_trucks_st_3" placeholder="Trucks St3 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['trucks']['stage_3'])) {
                                        echo $catalogData['fixed_stage_prices']['trucks']['stage_3']; } ?>">
                                </label>
                            </fieldset>
                        </td>
                    </tr>
                    <tr>
                    <th scope="row"><?php _e("Fixed prices for snowmobiles", "ctr"); ?></th>
                    <td>
                        <fieldset>
                            <legend class="screen-reader-text"><span><?php _e("Show fixed prices on your site for snowmobiles", "ctr"); ?>?</span></legend>
                            <label for="fixed_price_snowmobiles_st_1">
                                <input name="fixed_stage_prices[snowmobiles][stage_1]" type="number" id="fixed_price_snowmobiles_st_1" placeholder="Snowmobiles St1 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['snowmobiles']['stage_1'])) {
                                    echo $catalogData['fixed_stage_prices']['snowmobiles']['stage_1']; } ?>">
                            </label>
                            <label for="fixed_price_snowmobiles_st_2">
                                <input name="fixed_stage_prices[snowmobiles][stage_2]" type="number" id="fixed_price_snowmobiles_st_2" placeholder="Snowmobiles St2 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['snowmobiles']['stage_2'])) {
                                    echo $catalogData['fixed_stage_prices']['snowmobiles']['stage_2']; } ?>">
                            </label>
                            <label for="fixed_price_snowmobiles_st_3">
                                <input name="fixed_stage_prices[snowmobiles][stage_3]" type="number" id="fixed_price_snowmobiles_st_3" placeholder="Snowmobiles St3 fixed price" value="<?php if(isset($catalogData['fixed_stage_prices']['snowmobiles']['stage_3'])) {
                                    echo $catalogData['fixed_stage_prices']['snowmobiles']['stage_3']; } ?>">
                            </label><br/>
                            <em><?php _e("Fixed prices override the prices you have entered in the CRM", "ctr"); ?></em>
                        </fieldset>
                        <input type="hidden" name="update_settings" value="1">
                    </td>
                </tr>
                </tbody></table>
                <input type="hidden" name="update_settings" value="1">
                <?php submit_button("Save"); ?> 
            </div>
            <div class="col">
                <h2><?php _e("Plugin instructions", "ctr"); ?></h2>
                <ol>
                    <li>- <?php _e("Enter your API key and click save, for help and API keys visit our ", "ctr"); ?> <a href="https://www.chiptuningreseller.com/"  target="_blank"><?php _e("API Support page", "ctr"); ?></a>.</li>
                    <li>- <?php _e("After entering your API key you can visit ", "ctr"); ?> <b>( <a href="<?php echo get_site_url() ?>/chip-tuning/" target="_blank"><?php echo get_site_url() ?>/chip-tuning/</a> )</b> <?php _e("to view your plugin", "ctr"); ?></li>
                </ol>
            </div>
    </form>
</div>