<?php

/**
 * Provide a admin area help info view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://www.chiptuningreseller.com
 * @since      3.1.1
 *
 * @package    Ctr
 * @subpackage Ctr/admin/partials
 */
?>
<!-- This file should primarily consist of HTML with a little bit of PHP. -->
<div id="chiptuningreseller-settings-container">
    <div class="chiptuningreseller-masthead__logo-container">
    <img style="float:right; padding-right:40px; padding-top:20px; max-width:300px;" class="chiptuningreseller-masthead__logo" src="<?php echo esc_url( plugins_url( '../../public/assets/chiptuningreseller-logo-black.png', __FILE__ ) ); ?>" alt="ChiptuningReseller"/>
    </div>
    <?php if(TESTMODE) { ?>
        <h3 class="msg-warning">Localhost testmode activated - connected to staging server!</h3>
    <?php } ?>
		<div class="card col-6">
			<h2 class="title">Customize your templates</h2>
            <p>Customizing the templates provided by ChiptuningReseller is very easy.<br/><a href="#" id="copyTemplates">Click here to copy the default template files to your theme folder</a> 
            or copy the files from /wp-content/plugins/ctr/public/templates yourself to your themefolder/chiptuningreseller.<br/><br/>See the <a href="<?php echo esc_url( plugins_url( '../../public/templates/README.txt', __FILE__ ) ); ?>" target="_blank">README file for advanced template instructions</a>.</p>
        </div>
		<div class="card col-6">
			<h2 class="title">How to add a shortcode in a template?</h2>
			<p>To add a shortcode in a template, you can use the Ctr_Helpers. These helpers will provide you the needed functionalities to embed a shortcode. You can also inject variables directly into it!
            An example usage of a shortcode:<br/><br/><strong>{!! CTR_Helpers::shortcode('example_shortcode') !!}</strong><br/><br/>
            This will add the 'example_shortcode' to the template.<br/><h3>Adding variables</h3>You can easily also inject variables like normal:
            <br/><br/><strong>{!! CTR_Helpers::shortcode('example_shortcode', ['var_1' => 'value', 'var_2' => 'value']) !!}</strong><br/><br/></p>
        </div>
		<div class="card col-6">
			<h2 class="title">Extensive documentation</h2>
			You can read the extensive documentation on our docs page:
            <a href="http://docs.chiptuningreseller.com/wp-plugin/" target="_blank">http://docs.chiptuningreseller.com/wp-plugin/</a>
        </div>
    
</div>

<script>
jQuery(document).ready(function($) {

    $( "#copyTemplates" ).click(function() {
        var confTrashCache = confirm("Are you 100% sure?\nIf you have customized templates already, THESE WILL BE SKIPPED!");
        if (confTrashCache == true) {
            jQuery.post(ajaxurl, {'action': 'copy_templates'}, function(response) {
                alert(response);
            });    
        } else {
            txt = "Nothing done";
        }
        
    });
});

</script>