<?php
global $wp;

include('base.ctr.php');


// The widget class
class CTRWidget extends WP_Widget {
	

	// Main constructor
	public function __construct() {
		parent::__construct(
			'CTR_WIDGET',
			__( 'Chiptuning Reseller Widget', 'text_domain' ),
			array(
				'customize_selective_refresh' => true,
			)
		);

		
	}

	// The widget form (for the backend )
	public function form( $instance ) {

		// Set widget defaults
		$defaults = array(
			'title'    => '',
			'text'     => '',
			'textarea' => '',
			'checkbox' => '',
			'select'   => '',
		);
		
		// Parse current settings with defaults
		extract( wp_parse_args( ( array ) $instance, $defaults ) ); ?>

		<?php // Widget Title ?>
		<p>
			<label for="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>"><?php _e( 'Widget Title', 'text_domain' ); ?></label>
			<input class="widefat" id="<?php echo esc_attr( $this->get_field_id( 'title' ) ); ?>" name="<?php echo esc_attr( $this->get_field_name( 'title' ) ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		</p>
	<?php }

	// Update widget settings
	public function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title']    = isset( $new_instance['title'] ) ? wp_strip_all_tags( $new_instance['title'] ) : '';
		return $instance;
	}

	// Display the widget
	public function widget( $args, $instance ) {
		$CTR_BASE = new CTR_BASE();
		$SETTINGS = $CTR_BASE->get_settings();
		$PLUGIN_ROOT_URL = get_home_url() . '/'. $SETTINGS['start_url'];
		$ASSETS_URL = content_url('uploads/ctr/assets/');
		$MEDIA_URL = get_home_url() . '/'. $SETTINGS['start_url'] . '/assets/media/';
		//$CTR_BASE->create_headers();
		//$params = $CTR_BASE->get_query_vars();
		$VEHICLE_TYPES  = $CTR_BASE->get_types();

		extract( $args );

		// Check the widget options
		$title    = isset( $instance['title'] ) ? apply_filters( 'widget_title', $instance['title'] ) : '';

		// WordPress core before_widget hook (always include )
		echo $before_widget;
		if(isset($_POST['nothing'])) {
		 	//echo 'WE GOT POST';
			// Important: use wordpress' own post handling here!
		}
		// Display the widget
		echo '<div class="widget-text wp_widget_plugin_box">';
		include(CHIPTUNINGRESELLER_PLUGIN_DIR . 'views/front/selector.php');
		echo '</div>';

		// WordPress core after_widget hook (always include )
		echo $after_widget;

	}

}

// Register the widget
function register_chiptuningreseller_widget() {
	register_widget( 'CTRWidget' );
}
add_action( 'widgets_init', 'register_chiptuningreseller_widget' );