<?php
/**
 * Vehicle Types Class
 *
 * This class communicates with the CTR database
 *
 * @since      3.0.0
 * @package    Ctr
 * @subpackage Ctr/includes
 * @author     M Bos <support@chiptuningreseller.com>
 */
require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-ctr-helpers.php';
require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-ctr-db.php';

class Ctr_VehicleTypes {

    private $helper;
    private $settings;

    /**
	 * Initialize the class and set its properties.
	 *
	 * @since    3.0.0
	 * @param      string    $plugin_name       The name of this plugin.
	 * @param      string    $version    The version of this plugin.
	 */
	public function __construct($settings = null) {
		$this->helper = new Ctr_Helpers();
        $this->database = new Ctr_DB();
        $this->settings = null != $settings ? $settings : $this->database->getSettings();

    }
    

    public function getAllTypes() {
        $cached = $this->helper->get_cache('types');
        if(false !== $cached && isset($this->settings['enable_cache'])) {
            if(is_string($cached)) {
                if(strlen($cached) > 0) {
                    return $cached;
                }
            } else if((is_array($cached)) && (count($cached) > 0)) {
                return $cached;
            }
        }

        global $wpdb;
        $catalogData = null;
        $catalogData = $wpdb->get_row("SELECT * FROM {$wpdb->prefix}chiptuningreseller WHERE id=1", ARRAY_A);
        $url = API_URL . 'types';
        $response = wp_remote_get(
                $url, array(
                    'body' => '',
                    'timeout' => 30,
                    'headers' => [
                    'Authorization' => 'Bearer ' . $catalogData['api_key']
                ]
            )
        );
        if (is_wp_error( $response )) {
           $error_message = $response->get_error_message();
           //echo "Something went wrong: $error_message";
        } else {
           $responseData = json_decode($response['body'], true);
           $this->helper->set_cache('types', $responseData);
           return $responseData;
        }
    }

    public function getTypes($id) {

    }

}