<?php
$startSlug = (isset($data['translated_vehicle_type']) && isset($data['brandSlug']) && isset($data['start_url']) && isset($data['serieSlug'])) ?  $data['start_url'] . $data['translated_vehicle_type'] . '/' . $data['brandSlug'] . '/' . $data['serieSlug'] . '/' : '';

if (isset($data['builds']) && isset($ctrDisplay)) {
  $buildData = [];
  $serieImage = $ASSETS_URL . $data['translated_vehicle_type'] . '_placeholder.png';
  $data['serieImage'] = $ctrMedia->get_model_media('series', $data['serieId'], 'medium', $data['translated_vehicle_type']);
  $i = 0;
  foreach ($data['builds'] as $idx => $build) {
    if (isset($build['serie_id'])) {
      $buildData[$i]['name'] = $ctrHelpers->cleanString($build['name']);
      $buildData[$i]['slug'] = $startSlug . $build['slug'] . $data['trailingSlash'];
      $buildData[$i]['image'] = $ASSETS_URL . $data['translated_vehicle_type'] . '_placeholder.png';
      $buildData[$i]['enginecount'] = isset($build['enginecount']) ? $build['enginecount'] : '';
      $imageLink = $data['serieImage'];

      /** Retrieve all media attached to this item */
      if (is_array($build['media']) && count($build['media']) !== 0) {
        $mediaId = $build['media'][0]['id'];
        $imageLink = $ctrMedia->get_media($build['media'][0]['id'], 'builds', NULL, 'medium');
      } else {
        $imageLink = $ctrMedia->get_model_media('builds', $build['id'], 'medium');
      }
      
      if (is_numeric($idx)) {
        if (strpos($imageLink, 'placeholder') === false) {
          $buildData[$i]['image'] = '<img src="' . $imageLink . '" alt="' . $build['name'] . '"  title="' . $build['name'] . '">';
        } else {
          if (isset($data['serieImage'])) {
            // Get the serie image if no build image is present (and if the serieImage is presend)
            $buildData[$i]['image'] = '<img src="' . $data['serieImage'] . '" alt="' . $build['name'] . '"  title="' . $build['name'] . '">';
          } else {
            $buildData[$i]['image'] = '<img src="' . $ASSETS_URL . $data['translated_vehicle_type'] . '_placeholder.png" alt="' . $build['name'] . '"  title="' . $build['name'] . '">';
          }
        }
      }
    }
    $i++;
  }

  $injectData = [
    'urlAssets' => $ASSETS_URL,
    'lblSelectABuild' => esc_html__('Please select a build for', 'ctr'),
    'lblSelectAnEngine' => esc_html__('Please select an engine for', 'ctr'),
    'lblBrandName' => isset($data['brandName']) ? $data['brandName'] : '',
    'lblSerieName' => isset($data['serieName']) ? $data['serieName'] : '',
    'lblBackTo' => esc_html__('Back to', 'ctr'),
    'lblItems' => esc_html__('Items', 'ctr'),
    'lblOneBuildRedirecting' => esc_html__('Only one build found, redirecting you immediately...', 'ctr'),
    'backUrl' => isset($data['backUrl']) ? $data['backUrl'] : '',
    'dataBuilds' => $buildData,
    'isRedirected' => (isset($data['redirecting'])) ? true : false,
    'is_admin' => $data['is_admin']    
  ];

  // Check if a custom template exists in the theme folder, if not, load the plugin template file
  if (file_exists($CUSTOM_TPL_PATH . 'builds.template.php')) {
    echo '<!--- Custom template found, loading from there --->';
    $ctrDisplay->renderFile('builds', $injectData, $CUSTOM_TPL_PATH);
  } else {
    $ctrDisplay->renderFile('builds', $injectData);
  }
} else {
  ?>
  <h4>Sorry, no builds found...</h4>
<?php } ?>