<?php
$startSlug = (isset($data['translated_vehicle_type']) && isset($data['brandSlug']) && isset($data['start_url']) && isset($data['serieSlug']) && isset($data['buildSlug'])) ?  $data['start_url'] . $data['translated_vehicle_type'] . '/' . $data['brandSlug'] . '/' . $data['serieSlug'] . '/'  . $data['buildSlug'] . '/' : '';

if (isset($data['engines']) && isset($ctrDisplay)) {
  $i = 0;
  $engineData = [];
  foreach ($data['engines'] as $idx => $engine) {
    if (isset($engine['build_id'])) {
      $engineData[$i]['id'] = $engine['id'];
      $engineData[$i]['name'] = $ctrHelpers->cleanString($engine['name']);
      $engineData[$i]['slug'] = $startSlug . $engine['slug'];
      $engineData[$i]['hp'] = $engine['hp'];
      $engineData[$i]['kw'] = round($engine['hp'] * 0.745699872);
      $engineData[$i]['fuel'] = $ctrHelpers->translate_fuel_type('lbl_fuel_' . $engine['fuel_type'], $ctrSettings['display_lang']);
      $engineData[$i]['image'] = '';
      if (is_array($engine['media']) && count($engine['media']) !== 0) {
        $mediaId = $engine['media'][0]['id'];
        $engineData[$i]['image'] = '<img src="' . $ctrMedia->get_media($mediaId, 'engines') . '" alt="' . $engine['name'] . '" title="' . $engine['name'] . '">';
      }
      $i++;
    }
  }

  /** Prepare all data to be injected into the template */
  $injectData = [
    'urlAssets' => $ASSETS_URL,
    'lblSelectAnEngine' => esc_html__('Please select an engine for', 'ctr'),
    'lblBrandName' => isset($data['brandName']) ? $data['brandName'] : '',
    'lblSerieName' => isset($data['serieName']) ? $data['serieName'] : '',
    'lblBuildName' => isset($data['buildName']) ? $data['buildName'] : '',
    'lblPowerShort' => esc_html__('HP', 'ctr'),
    'lblBackTo' => esc_html__('Back to', 'ctr'),
    'backUrl' => isset($data['backUrl']) ? $data['backUrl'] : '',
    'dataEngines' => $engineData,
    'is_admin' => $data['is_admin'],
    'trailingSlash' =>  $data['trailingSlash']
  ];

  // Check if a custom template exists in the theme folder, if not, load the plugin template file
  if (file_exists($CUSTOM_TPL_PATH . 'engines.template.php')) {
    echo '<!--- Custom template found, loading from there --->';
    $ctrDisplay->renderFile('engines', $injectData, $CUSTOM_TPL_PATH);
  } else {
    $ctrDisplay->renderFile('engines', $injectData);
  }
} else {
?>
  <h4>Sorry, no engines found...</h4>
<?php
}
?>