	<?php
	if (!isset($data)) {
		return null;
	}
	$barBackgroundColor = isset($ctrSettings['layout_settings']['graph_colors']['original']) ? $ctrSettings['layout_settings']['graph_colors']['original']['hp'] : '#000000';
	$jsonData = $ctrSelectorApi->getSelectorData();
	$jsonDataPath = $ctrSelectorApi->getSelectorDataPath();
	?>
	<script>
		<?php if (isset($data['vehicle_types'])) { ?>var vTypes = <?php echo $data['vehicle_types']; } ?>;
			var vData = <?php echo $jsonData; ?>;
			var homeUrl = '<?php echo get_home_url(); ?>';
	</script>
	<?php
	// Check if a custom template exists in the theme folder, if not, load the plugin template file
	if ((isset($CUSTOM_TPL_PATH)) && (file_exists($CUSTOM_TPL_PATH . 'widgets/new.selector.template.php'))) {
		require($CUSTOM_TPL_PATH . 'widgets/new.selector.template.php');
	} else { ?>
		<div class="selectorSpace row" id="selectorApp">
			<div class="col-sm-12 col-md-2 col-lg-2 selectorControl selectTypeControl nopadding">
				<label for="selectType"><?php esc_html_e('Type', 'ctr'); ?></label>
				<select class="form-control js-select2" name="type" id="selectType" v-model="selectedType"  @change="typeSelected">
					<option value="0" selected>-- <?php esc_html_e('Please select vehicle type', 'ctr'); ?> --</option>
					<option v-for="type in typeData" :value="type.value" :key="type.value">{{ type.name }}</option>
				</select>
			</div>
			<div class="col-sm-12 col-md-2 col-lg-2 selectorControl selectBrandControl nopadding">
				<label for="selectBrand"><?php esc_html_e('Brand', 'ctr'); ?><span id="selectBrandCounter" class="itemCounter"></span></label>
				<select :disabled="selectedBrands.length == 0" class="form-control" :class="{'refreshed': brandsLoaded}" name="brand" id="selectBrand" @change="brandSelected">
					<option value="0" selected v-if="selectedBrands.length == 0">-- <?php esc_html_e('Please select type first', 'ctr'); ?> --</option>
					<option value="0" selected v-else>-- <?php esc_html_e('Select brand', 'ctr'); ?> --</option>
					<option v-for="brand in selectedBrands" :value="brand.id" :key="brand.id">{{ brand.name }}</option>
				</select>
			</div>
			<div class="col-sm-12 col-md-3 col-lg-3  selectorControl selectSerieControl nopadding">
				<label for="selectSerie"><?php esc_html_e('Serie', 'ctr'); ?><span id="selectSerieCounter" class="itemCounter"></span></label>
				<select :disabled="selectedSeries.length == 0" class="form-control" :class="{'refreshed': seriesLoaded}" name="serie" id="selectSerie" @change="serieSelected">
					<option value="0" selected v-if="selectedSeries.length == 0">-- <?php esc_html_e('Please select brand first', 'ctr'); ?> --</option>
					<option value="0" selected v-else>-- <?php esc_html_e('Select serie', 'ctr'); ?> --</option>
					<option v-for="serie in selectedSeries" :value="serie.id" :key="serie.id">{{ serie.name }}</option>
				</select>
			</div>
			<div class="col-sm-12 col-md-3 col-lg-3  selectorControl selectBuildControl nopadding">
				<label for="selectBuild"><?php esc_html_e('Build', 'ctr'); ?><span id="selectBuildCounter" class="itemCounter"></span></label>
				<select :disabled="selectedBuilds.length == 0" class="form-control" :class="{'refreshed': buildsLoaded}" name="builds" id="selectBuild" @change="buildSelected">
					<option value="0" selected v-if="selectedBuilds.length == 0">-- <?php esc_html_e('Please select a serie first', 'ctr'); ?> --</option>
					<option value="0" selected v-else>-- <?php esc_html_e('Select serie', 'ctr'); ?> --</option>
					<option v-for="build in selectedBuilds" :value="build.id" :key="build.id">{{ build.name }}</option>
				</select>
			</div>
			<div class="col-sm-12 col-md-3 col-lg-3  selectorControl selectEngineControl nopadding">
				<label for="selectEngine"><?php esc_html_e('Engine', 'ctr'); ?></label>
				<select :disabled="selectedEngines.length == 0" class="form-control" :class="{'refreshed': enginesLoaded}" name="engines" id="selectEngine" @change="engineSelected">
					<option value="0" selected v-if="selectedEngines.length == 0">-- <?php esc_html_e('Please select a build first', 'ctr'); ?> --</option>
					<option value="0" selected v-else>-- <?php esc_html_e('Select engine', 'ctr'); ?> --</option>
					<option v-for="engine in selectedEngines" :value="engine.id" :key="engine.id">{{ engine.name }} {{ engine.hp }} <?php esc_html_e('HP', 'ctr'); ?></option>
				</select>
			</div>
			<div v-show="redirectLoading" id="loadingDiv" :class="{'fadeInLoader': redirectLoading}">
				<img src="<?php echo get_home_url(); ?>/wp-content/plugins/ctr/public/assets/wheel.png" />
				
			</div>
			<div class="loader loaderLoading" v-show="redirectLoading"></div>
		</div>
		<div style="clear:both;"></div>
		<style>
			.selectorControl { display:block; position:relative; width: 15%; float:left; margin-right:20px;}
			.selectorControl input, label { width:100%; display:block; clear:both; }
			.selectorControl .form-control { width:100%; }
			#loadingDiv {position: absolute; display: block;width: 100%;text-align: center;left: 0px;height: 6%;padding-top: 10px;background-color: rgba(255,255,255, 0.9);}
			#loadingDiv img {animation: rotation 1s infinite linear;}
			.fadeInLoader { animation: fadeIn 0.3s linear; }
			.loader { width:100%; display:block; position:relative; height: 2px; top:50px; background-color:grey;}
			.loaderLoading {animation: loader 4s linear; }
			@keyframes fadeIn {0% { opacity:0; }100% { opacity:1; }}
			@keyframes rotation {from {transform: rotate(0deg);}to {transform: rotate(359deg);}}
			@keyframes loader {0% {width: 100%;}100% {width: 0%;}}
		</style>
		<?php } ?>