	
<?php
if (!isset($data)) {
	return null;
}
$barBackgroundColor = isset($ctrSettings['layout_settings']['graph_colors']['original']) ? $ctrSettings['layout_settings']['graph_colors']['original']['hp'] : '#000000';
?>
<link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-beta.1/dist/css/select2.min.css" rel="stylesheet" />
<script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-beta.1/dist/js/select2.min.js"></script>
<?php
// Check if a custom template exists in the theme folder, if not, load the plugin template file
if ((isset($CUSTOM_TPL_PATH)) && (file_exists($CUSTOM_TPL_PATH . 'widgets/selector.template.php'))) {
	require($CUSTOM_TPL_PATH . 'widgets/selector.template.php');
} else { ?>
	<div class="selectorSpace row">
		<div class="col-sm-12 col-md-2 col-lg-2 selectorControl selectTypeControl nopadding">
			<label for="selectType"><?php esc_html_e('Type', 'ctr'); ?></label>
			<select class="form-control js-select2" name="type" id="selectType">
				<option value="0" selected>-- <?php esc_html_e('Please select vehicle type', 'ctr'); ?> --</option>
				<?php if (isset($data['vehicle_types']['types'])) {
					foreach ($data['vehicle_types']['types'] as $vType) {
						if (((is_array($ctrSettings['show_vehicles'])) && array_key_exists(strtolower($vType['slug']), $ctrSettings['show_vehicles'])) || !is_array($ctrSettings['show_vehicles'])) {
							$translatedSlug = $ctrHelpers->translate_vehicle_type(strtolower($vType['slug']), $ctrSettings['display_lang']);
							$selected = (isset($data['vehicle_type'])) && ($vType['slug'] == $data['vehicle_type']) ? 'selected' : '';
							echo '<option ' . $selected . ' value="' . $vType['slug'] . '">' . ucfirst(str_replace('-', ' ', $translatedSlug)) . '</option>';
						}
					}
				} ?>
			</select>
		</div>
		<div class="col-sm-12 col-md-2 col-lg-2 selectorControl selectBrandControl nopadding">
			<label for="selectBrand"><?php esc_html_e('Brand', 'ctr'); ?><span id="selectBrandCounter" class="itemCounter"></span></label>
			<select class="form-control selector js-select2" name="brand" id="selectBrand">
				<option value="0">-- <?php esc_html_e('Please select a brand', 'ctr'); ?> --</option>
				<?php if (!isset($brands)) { ?>
					<option value="0">-- <?php esc_html_e('Please select a vehicle type first', 'ctr'); ?> --</option>
					<?php
				} else {
					foreach ($brands as $brand) {
						$selected = $brand['id'] == $brand_id ? 'selected' : '';
					?>
						<option <?php echo $selected; ?> value="<?php echo $brand['id']; ?>"><?php echo $brand['name']; ?></option>
				<?php
					}
				}
				?>
			</select>
		</div>
		<div class="col-sm-12 col-md-3 col-lg-3  selectorControl selectSerieControl nopadding">
			<label for="selectSerie"><?php esc_html_e('Serie', 'ctr'); ?><span id="selectSerieCounter" class="itemCounter"></span></label>
			<select class="form-control selector js-select2" name="serie" id="selectSerie">
				<option value="0">-- <?php esc_html_e('Please select a serie', 'ctr'); ?> --</option>
				<?php if (!isset($series)) { ?>
					<option value="0">-- <?php esc_html_e('Please select a brand first', 'ctr'); ?> --</option>
					<?php
				} else {
					foreach ($series as $k => $serie) {
						if ($k !== 'brand') { //we dont want brands to show up in our serie dropdown
							$selected = $serie['id'] == $serie_id ? 'selected' : '';
					?>
							<option <?php echo $selected; ?> value="<?php echo $serie['id']; ?>"><?php echo $serie['name']; ?></option>
				<?php
						}
					}
				}
				?>
			</select>
		</div>
		<div class="col-sm-12 col-md-2 col-lg-2  selectorControl selectBuildControl nopadding">
			<label for="selectBuild"><?php esc_html_e('Build', 'ctr'); ?><span id="selectBuildCounter" class="itemCounter"></span></label>
			<select class="form-control selector js-select2" name="build" id="selectBuild">
				<option value="0">-- <?php esc_html_e('Please select a build', 'ctr'); ?> --</option>
				<?php if (!isset($builds)) { ?>
					<option value="0">-- <?php esc_html_e('Please select a serie first', 'ctr'); ?> --</option>
					<?php
				} else {
					foreach ($builds as $k => $build) {
						if ($k !== 'brand' && $k !== 'serie') {
							$selected = $build['id'] == $build_id ? 'selected' : '';
					?>
							<option <?php echo $selected; ?> value="<?php echo $build['id']; ?>"><?php echo $build['name']; ?></option>
				<?php
						}
					}
				}
				?>
			</select>
		</div>
		<div class="col-sm-12 col-md-3 col-lg-3 selectorControl selectEngineControl nopadding">
			<label for="selectEngine"><?php esc_html_e('Engine', 'ctr'); ?><span id="selectEngineCounter" class="itemCounter"></span></label>
			<select class="form-control selector js-select2" name="engine" id="selectEngine">
				<option value="0">-- <?php echo esc_html_e('Please select an engine', 'ctr'); ?> --</option>
				<?php if (!isset($engines)) { ?>
					<option value="0">-- <?php esc_html_e('Please select a build first', 'ctr'); ?> --</option>
					<?php
				} else {
					foreach ($engines as $k => $engine) {
						if ($k !== 'brand' && $k !== 'serie' && $k !== 'build') {
							$selected = $engine['id'] == $engine_id ? 'selected' : '';
					?>
							<option <?php echo $selected; ?> value="<?php echo $engine['id']; ?>"><?php echo $engine['name']; ?> (<?php echo $engine['hp'];
																																	esc_html_e("hp", "ctr"); ?>)</option>
				<?php
						}
					}
				}
				?>
			</select>
		</div>
		<div id="loadingDiv"><span class="ctrLoader"><img src="<?php echo get_home_url(); ?>/wp-content/plugins/ctr/public/assets/wheel.png" /></span></div>
		<div id="launcherAnimation">
			<div class="load-bar" style="background-color: <?php echo $barBackgroundColor; ?>">
				<div class="bar"></div>
				<div class="bar"></div>
				<div class="bar"></div>
			</div>
		</div>
	</div>
	<script>
	var $loading = jQuery('.ctrLoader');
	$loading.hide();
	jQuery(document)
		.ajaxStart(function() {
			$loading.show();
		})
		.ajaxStop(function() {
			$loading.hide();
		});

	jQuery(document).ready(function($) {

		$('.js-select2').select2();

		$('#linkButton').hide();
		$('#launcherAnimation').hide();
		var vehicle_type = '<?php echo isset($data['translated_vehicle_type']) ? $data['translated_vehicle_type'] : 'null'; ?>';
		var vehicle_brand = '<?php echo isset($data['brandId']) ? $data['brandId'] : 'null'; ?>';
		var vehicle_series = '<?php echo isset($data['serieId']) ? $data['serieId'] : 'null'; ?>';
		var vehicle_build = '<?php echo isset($data['vehicle_build']) ? $data['vehicle_build'] : 'null'; ?>';


		if (vehicle_type !== 'null') {
			loadBrands($("#selectType option:selected").val());
		}

		if ($("#selectType > option").length == 2) { // Only one vehicle type activated. Then automatically select the correct brands directly.
			$("#selectType option:first").remove(); // Remove the 0 item
			loadBrands($("#selectType option:first").val());
			$("#selectSerie").empty();
			$("#selectBuild").empty();
			$("#selectEngine").empty();
			$(".selectTypeControl").hide();
		}

		$("#selectType").change((evt) => {
			loadBrands(evt.target.value);
			$("#selectBrand").empty();
			$("#selectSerie").empty();
			$("#selectBuild").empty();
			$("#selectEngine").empty();
		});

		function animateSelectLoading(target) {
			target.hide();
			target.empty();
			target.append($("<option />").val(0).text('... <?php esc_html_e('Loading', 'ctr'); ?> ...'));
		}

		function loadBrands() {
			var typeSlug = $("#selectType").val();
			var brandDropdown = $("#selectBrand");

			$('#stageTableWrapper').html('<h3><?php esc_html_e('Please first complete your selection...', 'ctr'); ?></h3>');
			$('#linkButton').hide();

			animateSelectLoading(brandDropdown);

			$.getJSON("<?php echo get_home_url(); ?>/", {
				'ctr_active': true,
				'ctr_vehicle_type': typeSlug,
				'ajax': true
			}, (data, status) => {
				brandDropdown.empty();
				brandDropdown.append($("<option />").val(0).text('-- <?php esc_html_e('Please select a brand', 'ctr'); ?> (' + data.length + ')--'));
				$.each(data, function() {
					brandDropdown.append($("<option />").val(this.id).text(this.name));
				});
				$('#selectBrandCounter').text(' (' + data.length + ')');
				brandDropdown.show();
				if (vehicle_brand != 'null') {
					$("#selectBrand").val(vehicle_brand);
					$("#selectBrand").change();
				}
			});
		}

		$("#selectBrand").change(function(evt) {
			$('#stageTableWrapper').html('');
			$('#overviewPlaceholder').html('');
			$('#linkButton').hide();
			var brandId = $("#selectBrand").val();
			var serieDropdown = $("#selectSerie");
			$("#selectBuild").empty();
			$("#selectEngine").empty();
			animateSelectLoading(serieDropdown);
			$('#brandLogo').attr('src', './?ajax=1&brand_logo=' + brandId);

			$.getJSON("<?php echo get_home_url(); ?>/", {
				'ctr_active': true,
				'ctr_brand_id': brandId,
				'ajax': true
			}, function(data, status) {
				if (data !== null) {
					serieDropdown.empty();

					if (data.length == 1) {
						var mimicChange = true;
						$('#selectSerieCounter').text(' (1)');
					} else {
						var mimicChange = false;
						$('#selectSerieCounter').text(' (' + data.length + ')');
						serieDropdown.append($("<option />").val(0).text('-- <?php esc_html_e('Select a serie', 'ctr'); ?> (' + data.length + ')--'));
					}

					$.each(data, function() {
						serieDropdown.append($("<option />").val(this.id).text(this.name));
					});

					<?php if(isset($data['serieId'])) { ?>
						$('#selectSerie').val(<?php echo $data['serieId']; ?>);
						serieDropdown.change();
					<?php } ?>

					serieDropdown.show();
					if (mimicChange) {
						serieDropdown.change();
						return;
					}
				}
			});
		});

		$("#selectSerie").change(function(evt) {
			$('#stageTableWrapper').html('');
			$('#overviewPlaceholder').html('');
			$('#linkButton').hide();
			var serieId = $("#selectSerie").val();
			var buildDropdown = $("#selectBuild");
			$("#selectEngine").empty();
			animateSelectLoading(buildDropdown);

			$.getJSON("<?php echo get_home_url(); ?>/", {
				'ctr_active': true,
				'ctr_serie_id': serieId,
				'ajax': true
			}, function(data, status) {
				buildDropdown.empty();
				if (data.length == 1) {
					var mimicChange = true;
					$('#selectBuildCounter').text(' (1)');
				} else {
					var mimicChange = false;
					$('#selectBuildCounter').text(' (' + data.length + ')');
					buildDropdown.append($("<option />").val(0).text('-- <?php esc_html_e('Select a build', 'ctr'); ?> (' + data.length + ')--'));
				}

				$.each(data, function() {
					buildDropdown.append($("<option />").val(this.id).text(this.name));
				});

				<?php if(isset($data['serieId'])) { ?>
					$('#selectSerie').val(<?php echo $data['serieId']; ?>);
				<?php } ?>

				<?php if(isset($data['buildId'])) { ?>
					$('#selectBuild').val(<?php echo $data['buildId']; ?>);
					buildDropdown.change();
				<?php } ?>

				buildDropdown.show();

				if (mimicChange) {
					buildDropdown.change();
					return;
				}
			});
		});

		/** Select the build for a vehicle **/
		$("#selectBuild").change(function(evt) {
			$('#stageTableWrapper').html('');
			$('#overviewPlaceholder').html('');
			$('#linkButton').hide();
			var buildId = $("#selectBuild").val();
			var engineDropdown = $("#selectEngine");
			animateSelectLoading(engineDropdown);

			$.getJSON("<?php echo get_home_url(); ?>/", {
				'ctr_active': true,
				'ctr_build_id': buildId,
				'ajax': true
			}, function(data, status) {
				engineDropdown.empty();

				if (data.length == 1) {
					var mimicChange = true;
					$('#selectEngineCounter').text('(1)');
				} else {
					var mimicChange = false;
					$('#selectEngineCounter').text(' (' + data.length + ')');
					engineDropdown.append($("<option />").val(0).text('-- <?php esc_html_e('Select an engine', 'ctr'); ?> (' + data.length + ')--'));
				}

				$.each(data, function() {
					engineDropdown.append($("<option />").val(this.id).text(this.name + " (" + this.hp + "<?php esc_html_e("hp", "ctr"); ?>)"));
				});

				<?php if(isset($data['dataEngine']['id'])) { ?>
					$('#selectEngine').val(<?php echo $data['dataEngine']['id']; ?>);
					engineDropdown.change();
				<?php } ?>

				engineDropdown.show();
				if (mimicChange) {
					engineDropdown.change();
					return;
				}
			});
		});

		$("#selectEngine").change(function(evt) {
			getStages();
		});

		function getStages() {
			$('#stageTableWrapper').html('');
			var engineId = $("#selectEngine").val();
			if (engineId) {
				

				$.getJSON("<?php echo get_home_url(); ?>/", {
					'ctr_active': true,
					'ctr_engine_id': engineId,
					'ajax': true
				}, function(data, status) {
					$('#selectedEngine').val(engineId);
					if (data.url && !window.location.href.includes(data.url)) {
						$('#launcherAnimation').fadeIn();
						$('.selectorControl').slideUp(500);
						var redirUrl = data.url;
						window.location.href = redirUrl;
					}
					$('#selectedEngine').val(engineId);
				});
			}
		}
	});
</script>
<?php
}
if (isset($ctrSettings['custom_css'])) { ?>
	<style>
		<?php echo $ctrSettings['custom_css']; ?>
	</style>
<?php } ?>
