@foreach($dataCharts as $chartDataItem)
    <div class="col-md-{!! 12 / $numberOfStages !!} pull-left">
        <div class="col dynoChartBox">
                <canvas id="ctrDoughnutChart_{!! $chartDataItem['slug'] !!}"></canvas>
                <div class="dynoChartBoxBackground">
                <h4>{{ $chartDataItem['label'] }}</h4>
                </div>
        </div>
    </div>
@endforeach

<script type="text/javascript">
// this is JS code
document.addEventListener('DOMContentLoaded', function() {
@foreach($dataCharts as $chartDataItem)
    var doughnutChart = document.getElementById("ctrDoughnutChart_{!! $chartDataItem['slug'] !!}");
    if (doughnutChart !== null && typeof(doughnutChart) !== 'undefined') {
        var ctx = doughnutChart.getContext('2d');
        var doughnutChart = new Chart(ctx, {
            backgroundColor: "transparent",
            type: 'doughnut',
            data: {
                labels: ["{!! $chartDataItem['label'] !!} {!! $lblPower !!}", "{{ $lblStandardText }} {!! $lblPower !!}"],
                datasets: [{
                    label: "{!! $lblPower !!}",
                    data: [{!! $chartDataItem['hpData'] !!}, {!! $chartDataItem['hpOriginal'] !!}],
                    backgroundColor: ["{!! $chartDataItem['dataHpBgColor_tuning'] !!}", "{!! $chartDataItem['dataHpBgColor_original'] !!}"],
                    borderColor: ["{!! $chartDataItem['dataHpBorderColor_tuning'] !!}", "{!! $chartDataItem['dataHpBgColor_original'] !!}"],
                    borderWidth: 1
                }]
            },
            options: {
                responsiveAnimationDuration: 1500,
                responsive: true,
                legend: {
                    display: false
                },
            }
        });
    }
@endforeach
}, false);
</script>
<style>
.dynoChartBoxBackground {
    position: absolute;
    top: 7%;
    left: 43%;
    bottom: 0;
    right: 0;
    z-index: 0;
    overflow: hidden;
    width:75px;
}
canvas {
    //background-image: url('/wp-content/uploads/ctr/assets/ctr-charts-background.png');
    background-size: 60%;
    background-position: 30% 30%;
    background-repeat: no-repeat;
}
</style>