<!-- START TEMPLATE -->
<div class="row" style="background: #F2F7FF">

	<!-- The images shown on a stage page - If no stage images found, the serie will be shown --->

	<div class="col-sm-12 col-md-6 mb-5">
		<div class=" ctrWrapper ctrWrapperTitle">
			<div class="ctrBrandLogo">{!! $imgBrandImage !!}</div>
			<h4 class="ctrtuningTitle">{{ $lblSubtitle }} {{ $lblVehicleBrandName }} {{ $lblVehicleSerieName }} <span>{{ $lblVehicleBuildName }} ({{ $lblVehicleEngineName }})</span></h4>
		</div>

	</div>
	<div class="col-sm-12 col-md-6 mb-5">
		<div class="ctrWrapper ctrVehicleDetails">
			<div>
				<div class="ctrVehicleDetails--icon hoverGrow ctrVehicleDetails--icon-fuel"></div>
				<div class="ctrVehicleDetails--text">
					{{ $lblFuelType }}<br>
					<span>{{ $engineFuelType }}</span>
				</div>
			</div>
			<div>
				<div class="ctrVehicleDetails--icon hoverGrow ctrVehicleDetails--icon-engineHP"></div>
				<div class="ctrVehicleDetails--text">
					{{ $lblStandardText }} {{ $lblPowerShort }}<br>
					<span>{{ $dataEngine['hp'] }}</span>
				</div>
			</div>
			<div>
				<div class="ctrVehicleDetails--icon hoverGrow ctrVehicleDetails--icon-engineNM"></div>
				<div class="ctrVehicleDetails--text">
					{{ $lblStandardText }} {{ $lblTorqueShort }}<br>
					<span>{{ $dataEngine['nm'] }}</span>
				</div>
			</div>
		</div>

	</div>
</div>
<div class="row" style="background: #F2F7FF">
@if($configShowBasicTable)
	<div class="col-sm-12 col-md-6 mb-5">
		<div class="ctrWrapper">
			<!-- The stage table buttons - with these you can navigate through the different stages in the table --->
			@includeIf('partials.basic-table-buttons')
			@includeIf('partials.basic-table')

			<!-- If you want Custom Data blocks to be shown instead or underneath the stage table, add them here. We have added an example for you! -->
			<!-- <div class="customDataBlock targetName hideStage">
				Add your custom data here
			</div> -->
		</div>
	</div>
	@else
	<div class="col d-none d-md-block col-md-12 col-lg-6 mb-5">
		<div class="ctrWrapper">
			<br/><br/>
			<div class="stageTable ">
				@includeIf('partials.increaser-table')
			</div>
		</div>
	</div>
	@endif
	@if((isset($dataImageGallery)) && (strlen($dataImageGallery) > 0))
	<div class="col-sm-12 col-md-6 mb-5">
		<div class="ctrWrapper" style="text-align:center;">
		<div class="row">
			{!! $dataImageGallery !!}
		</div>
		@if((isset($dataStageMedia)) && (count($dataStageMedia) > 0))
		<br/>
			<div class="row">
			@foreach($dataStageMedia as $image)
				{!! $image !!}
			@endforeach
		</div>
		@endif
		</div>
		
	</div>
	@endif
</div>
<div class="row" style="background: #F2F7FF">
	@if($configShowBarChart)
	<div class="col d-none d-md-block col-md-6 mb-5">
		<div class="ctrWrapper">
			<div class="col dynoChartBox">
				<canvas id="barChart"></canvas>
			</div>
		</div>
	</div> @endif
	@if($configShowLineChart)
	<div class="col d-none d-md-block col-md-6 mb-5">
		<div class="ctrWrapper">
			<div class="col dynoChartBox">
				<canvas id="ctrLineChart"></canvas>
			</div>
		</div>
	</div>
	@endif
</div>
<div class="row" style="background: #F2F7FF">
	@if((isset($dataStageMedia)) && (count($dataStageMedia) > 0))
	<div class="col d-none d-md-block col-md-12 mb-5">
		<div class="large-12 stageSmallImages extraStageMedia">
			<div class="ctrWrapper" style="text-align:center;">
				<div class="row">
				@foreach($dataStageMedia as $image)
				{!! $image !!}
				@endforeach
				</div>
			</div>
		</div>
	</div>
	@endif
	@if($configShowEcuDetails)
	<div class="col d-none d-md-block col-md-6 mb-5">
		<div class="ctrWrapper">
			<div class="ecuAdvancedOptions">
				<div class="col-md-8 ecuDetails">
					@includeIf('partials.stage-ecudetails')
				</div>
				<div class="col-md-4 readMethods">
					@includeIf('partials.stage-readmethods')
				</div>
			</div>
		</div>
	</div>
	@endif

</div>
<div class="row" style="background: #F2F7FF">
	@if($configShowPieChart)
	<div class="col d-none d-md-block col-md-12 col-lg-6 mb-5">
		<div class="ctrWrapper">
			@includeIf('charts.pie')
		</div>
	</div>
	@endif
	@if($configShowIncreaserTable && $configShowBasicTable !== false)
	<div class="col d-none d-md-block col-md-12 col-lg-6 mb-5">
		<div class="ctrWrapper">
			<div class="stageTable ">
				@includeIf('partials.increaser-table')


				@includeIf('partials.stage-content')
			</div>
		</div>
	</div>
	@endif
</div>
<div class="row">
	<div class="col-md-6 shortcodeDisplayBlock d-md-block">
		{!! $dataShortcode !!}
	</div>
	<div class="col-md-6">





	</div>
</div>
<!-- You can edit the javascript functions to add custom behaviour for clicking the buttons --->
<script>
	jQuery(function(a) {
		a(".stageTableButton").on("click", function(evt) {
			
			var target = evt.target;
			if(target.nodeName == 'SPAN') {
				// if we click the span item inside the button, we lost focus and need to reset it.
				target = jQuery(target).closest('button')[0];
			}
			
			if (typeof(target.attributes.dataTarget) !== 'undefined') {
				if (target.attributes.dataHideTable.value == 'true') {
					jQuery('.stageTableBlock').hide();
				}
				a(".customDataBlock").addClass("hideStage");
				a('.' + target.attributes.dataTarget.value).removeClass("hideStage");
				a(".stageTableButton").removeClass("active");
				a(this).addClass("active")
			} else {
				jQuery('.stageTableBlock').show();
				a('.customDataBlock').addClass("hideStage");
				// a('.stageTable').show();
				a(".stageTableButton").removeClass("active");
				a(this).addClass("active");

				a(".stageTableRow").addClass("hideStage");
				a(".stageNameText").text(target.innerText);
				var e = target.attributes.sttarget.value;
				a("." + e).removeClass("hideStage")
			}
		});
		jQuery('div.stageButtons').children(':first').click();
	});
</script>
<style>
	.ctr-bootstrap .ecuAdvancedOptions {
		padding-top: 50px;
	}

	.ctr-bootstrap .tuningTitle {
		padding: 20px;
	}
</style>
<!-- END TEMPLATE -->